// This file is automatically generated from /root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb.pac.

#ifndef _root_rpmbuild_BUILD_bro_2_5_4_src_analyzer_protocol_rfb_rfb_pac_h
#define _root_rpmbuild_BUILD_bro_2_5_4_src_analyzer_protocol_rfb_rfb_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


	#include "events.bif.h"

namespace binpac {

namespace RFB {
class ContextRFB;
class RFB_Conn;
enum states {
	AWAITING_SERVER_BANNER = 0,
	AWAITING_CLIENT_BANNER = 1,
	AWAITING_SERVER_AUTH_TYPES = 2,
	AWAITING_SERVER_CHALLENGE = 3,
	AWAITING_CLIENT_RESPONSE = 4,
	AWAITING_SERVER_AUTH_RESULT = 5,
	AWAITING_CLIENT_SHARE_FLAG = 6,
	AWAITING_SERVER_PARAMS = 7,
	AWAITING_CLIENT_AUTH_METHOD = 8,
	AWAITING_SERVER_ARD_CHALLENGE = 9,
	AWAITING_CLIENT_ARD_RESPONSE = 10,
	AWAITING_SERVER_AUTH_TYPES37 = 11,
	AWAITING_CLIENT_AUTH_TYPE_SELECTED37 = 12,
	RFB_MESSAGE = 13,
};
class RFBProtocolVersion;
class RFBSecurityTypes;
class RFBSecurityTypes37;
class RFBAuthTypeSelected;
class RFBSecurityResult;
class RFBSecurityResultReason;
class RFBVNCAuthenticationRequest;
class RFBVNCAuthenticationResponse;
class RFBSecurityARDChallenge;
class RFBSecurityARDResponse;
class RFBClientInit;
class RFBServerInit;
class RFB_PDU_request;
class RFB_PDU_response;
class RFB_PDU;
class RFB_Flow;
} // namespace RFB

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
StringVal * utf16_bytestring_to_utf8_val(Connection * conn, bytestring const & utf16);
namespace RFB {

class ContextRFB
{
public:
	ContextRFB(RFB_Conn * connection, RFB_Flow * flow);
	~ContextRFB();
	
	// Member access functions
	RFB_Conn * connection() const { return connection_; }
	RFB_Flow * flow() const { return flow_; }
	
protected:
	RFB_Conn * connection_;
	RFB_Flow * flow_;
};


class RFB_Conn : public binpac::ConnectionAnalyzer
{
public:
	RFB_Conn(BroAnalyzer const & bro_analyzer);
	~RFB_Conn();
	
	// Member access functions
	RFB_Flow * upflow() const { return upflow_; }
	RFB_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	int get_state(bool client);
	bool handle_banners(bool client, RFBProtocolVersion * msg);
	bool handle_ard_challenge();
	bool handle_ard_response();
	bool handle_auth_request();
	bool handle_auth_response();
	bool handle_security_result(RFBSecurityResult * msg);
	bool handle_client_init(RFBClientInit * msg);
	bool handle_server_init(RFBServerInit * msg);
	bool handle_security_types(RFBSecurityTypes * msg);
	bool handle_security_types37(RFBSecurityTypes37 * msg);
	bool handle_auth_type_selected(RFBAuthTypeSelected * msg);
	
protected:
	
	// Additional members

		enum states {
			AWAITING_SERVER_BANNER = 0,
			AWAITING_CLIENT_BANNER = 1,
			AWAITING_SERVER_AUTH_TYPES = 2,
			AWAITING_SERVER_CHALLENGE = 3,
			AWAITING_CLIENT_RESPONSE = 4,
			AWAITING_SERVER_AUTH_RESULT = 5,
			AWAITING_CLIENT_SHARE_FLAG = 6,
			AWAITING_SERVER_PARAMS = 7,
			AWAITING_CLIENT_AUTH_METHOD = 8,
			AWAITING_SERVER_ARD_CHALLENGE = 9,
			AWAITING_CLIENT_ARD_RESPONSE = 10,
			AWAITING_SERVER_AUTH_TYPES37 = 11,
			AWAITING_CLIENT_AUTH_TYPE_SELECTED37 = 12,
			RFB_MESSAGE = 13
		};
	

		uint8 state = AWAITING_SERVER_BANNER;
		int version = 0;
	
	RFB_Flow * upflow_;
	RFB_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class RFBProtocolVersion
{
public:
	RFBProtocolVersion(bool client);
	~RFBProtocolVersion();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	bytestring const & header() const { return header_; }
	bytestring const & major_ver() const { return major_ver_; }
	bytestring const & dot() const { return dot_; }
	bytestring const & minor_ver() const { return minor_ver_; }
	uint8 pad() const { return pad_; }
	bool client() const { return client_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	bytestring header_;
	bytestring major_ver_;
	bytestring dot_;
	bytestring minor_ver_;
	uint8 pad_;
	bool client_;
	bool proc_;
	bool proc2_;
};


class RFBSecurityTypes
{
public:
	RFBSecurityTypes();
	~RFBSecurityTypes();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context, int t_byteorder);
	
	// Member access functions
	uint32 sectype() const { return sectype_; }
	bytestring const & possible_challenge() const { return possible_challenge_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	uint32 sectype_;
	bytestring possible_challenge_;
	bool proc_;
	bool proc2_;
};


class RFBSecurityTypes37
{
public:
	RFBSecurityTypes37();
	~RFBSecurityTypes37();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	uint8 count() const { return count_; }
	vector<uint8> * types() const { return types_; }
	bool proc() const { return proc_; }
	
protected:
	uint8 count_;
	vector<uint8> * types_;
	uint8 types__elem_;
	bool proc_;
};


class RFBAuthTypeSelected
{
public:
	RFBAuthTypeSelected();
	~RFBAuthTypeSelected();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	uint8 type() const { return type_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	uint8 type_;
	bool proc_;
	bool proc2_;
};


class RFBSecurityResult
{
public:
	RFBSecurityResult();
	~RFBSecurityResult();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context, int t_byteorder);
	
	// Member access functions
	uint32 result() const { return result_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	uint32 result_;
	bool proc_;
	bool proc2_;
};


class RFBSecurityResultReason
{
public:
	RFBSecurityResultReason();
	~RFBSecurityResultReason();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 len() const { return len_; }
	bytestring const & reason() const { return reason_; }
	
protected:
	uint32 len_;
	bytestring reason_;
};


class RFBVNCAuthenticationRequest
{
public:
	RFBVNCAuthenticationRequest();
	~RFBVNCAuthenticationRequest();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	bytestring const & challenge() const { return challenge_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring challenge_;
	bool proc_;
};


class RFBVNCAuthenticationResponse
{
public:
	RFBVNCAuthenticationResponse();
	~RFBVNCAuthenticationResponse();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	bytestring const & response() const { return response_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring response_;
	bool proc_;
};


class RFBSecurityARDChallenge
{
public:
	RFBSecurityARDChallenge();
	~RFBSecurityARDChallenge();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	bytestring const & challenge() const { return challenge_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring challenge_;
	bool proc_;
};


class RFBSecurityARDResponse
{
public:
	RFBSecurityARDResponse();
	~RFBSecurityARDResponse();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	bytestring const & response() const { return response_; }
	bool proc() const { return proc_; }
	
protected:
	bytestring response_;
	bool proc_;
};


class RFBClientInit
{
public:
	RFBClientInit();
	~RFBClientInit();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	uint8 shared_flag() const { return shared_flag_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	uint8 shared_flag_;
	bool proc_;
	bool proc2_;
};


class RFBServerInit
{
public:
	RFBServerInit();
	~RFBServerInit();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context, int t_byteorder);
	
	// Member access functions
	uint16 width() const { return width_; }
	uint16 height() const { return height_; }
	bytestring const & pixel_format() const { return pixel_format_; }
	uint32 len() const { return len_; }
	bytestring const & name() const { return name_; }
	bool proc() const { return proc_; }
	bool proc2() const { return proc2_; }
	
protected:
	uint16 width_;
	uint16 height_;
	bytestring pixel_format_;
	uint32 len_;
	bytestring name_;
	bool proc_;
	bool proc2_;
};


class RFB_PDU_request
{
public:
	RFB_PDU_request();
	~RFB_PDU_request();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	int request_case_index() const	{ return request_case_index_; }
	RFBProtocolVersion * version() const
		{
		switch ( request_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:107:version", request_case_index(), "AWAITING_CLIENT_BANNER");
				break;
			}
		return version_;
		}
	RFBVNCAuthenticationResponse * response() const
		{
		switch ( request_case_index() )
			{
			case 4:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:108:response", request_case_index(), "AWAITING_CLIENT_RESPONSE");
				break;
			}
		return response_;
		}
	RFBClientInit * shareflag() const
		{
		switch ( request_case_index() )
			{
			case 6:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:109:shareflag", request_case_index(), "AWAITING_CLIENT_SHARE_FLAG");
				break;
			}
		return shareflag_;
		}
	RFBAuthTypeSelected * authtype() const
		{
		switch ( request_case_index() )
			{
			case 12:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:110:authtype", request_case_index(), "AWAITING_CLIENT_AUTH_TYPE_SELECTED37");
				break;
			}
		return authtype_;
		}
	RFBSecurityARDResponse * ard_response() const
		{
		switch ( request_case_index() )
			{
			case 10:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:111:ard_response", request_case_index(), "AWAITING_CLIENT_ARD_RESPONSE");
				break;
			}
		return ard_response_;
		}
	uint8 state() const { return state_; }
	
protected:
	int request_case_index_;
	RFBProtocolVersion * version_;
	RFBVNCAuthenticationResponse * response_;
	RFBClientInit * shareflag_;
	RFBAuthTypeSelected * authtype_;
	RFBSecurityARDResponse * ard_response_;
	const_bytestring ignore_;
	const_bytestring data_;
	uint8 state_;
};


class RFB_PDU_response
{
public:
	RFB_PDU_response();
	~RFB_PDU_response();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context, int t_byteorder);
	
	// Member access functions
	int request_case_index() const	{ return request_case_index_; }
	RFBProtocolVersion * version() const
		{
		switch ( request_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:121:version", request_case_index(), "AWAITING_SERVER_BANNER");
				break;
			}
		return version_;
		}
	RFBSecurityTypes * auth_types() const
		{
		switch ( request_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:122:auth_types", request_case_index(), "AWAITING_SERVER_AUTH_TYPES");
				break;
			}
		return auth_types_;
		}
	RFBSecurityTypes37 * auth_types37() const
		{
		switch ( request_case_index() )
			{
			case 11:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:123:auth_types37", request_case_index(), "AWAITING_SERVER_AUTH_TYPES37");
				break;
			}
		return auth_types37_;
		}
	RFBVNCAuthenticationRequest * challenge() const
		{
		switch ( request_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:124:challenge", request_case_index(), "AWAITING_SERVER_CHALLENGE");
				break;
			}
		return challenge_;
		}
	RFBSecurityResult * authresult() const
		{
		switch ( request_case_index() )
			{
			case 5:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:125:authresult", request_case_index(), "AWAITING_SERVER_AUTH_RESULT");
				break;
			}
		return authresult_;
		}
	RFBSecurityARDChallenge * ard_challenge() const
		{
		switch ( request_case_index() )
			{
			case 9:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:126:ard_challenge", request_case_index(), "AWAITING_SERVER_ARD_CHALLENGE");
				break;
			}
		return ard_challenge_;
		}
	RFBServerInit * serverinit() const
		{
		switch ( request_case_index() )
			{
			case 7:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:127:serverinit", request_case_index(), "AWAITING_SERVER_PARAMS");
				break;
			}
		return serverinit_;
		}
	uint8 rstate() const { return rstate_; }
	
protected:
	int request_case_index_;
	RFBProtocolVersion * version_;
	RFBSecurityTypes * auth_types_;
	RFBSecurityTypes37 * auth_types37_;
	RFBVNCAuthenticationRequest * challenge_;
	RFBSecurityResult * authresult_;
	RFBSecurityARDChallenge * ard_challenge_;
	RFBServerInit * serverinit_;
	const_bytestring ignore_;
	const_bytestring data_;
	uint8 rstate_;
};


class RFB_PDU
{
public:
	RFB_PDU(bool is_orig);
	~RFB_PDU();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextRFB * t_context);
	
	// Member access functions
	int payload_case_index() const	{ return payload_case_index_; }
	RFB_PDU_request * request() const
		{
		switch ( payload_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:137:request", payload_case_index(), "true");
				break;
			}
		return request_;
		}
	RFB_PDU_response * response() const
		{
		switch ( payload_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/root/rpmbuild/BUILD/bro-2.5.4/src/analyzer/protocol/rfb/rfb-protocol.pac:138:response", payload_case_index(), "false");
				break;
			}
		return response_;
		}
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	bool proc() const { return proc_; }
	
protected:
	int payload_case_index_;
	RFB_PDU_request * request_;
	RFB_PDU_response * response_;
	bool is_orig_;
	int byteorder_;
	bool proc_;
};


class RFB_Flow : public binpac::FlowAnalyzer
{
public:
	RFB_Flow(RFB_Conn * connection, bool is_orig);
	~RFB_Flow();
	
	// Member access functions
	RFB_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	bool proc_rfb_message(RFB_PDU * msg);
	bool proc_rfb_version(bool client, bytestring const & major, bytestring const & minor);
	bool proc_rfb_share_flag(bool shared);
	bool proc_security_types(RFBSecurityTypes * msg);
	bool proc_security_types37(RFBAuthTypeSelected * msg);
	bool proc_handle_server_params(RFBServerInit * msg);
	bool proc_handle_security_result(uint32 result);
	
protected:
	RFB_PDU * dataunit_;
	ContextRFB * context_;
	RFB_Conn * connection_;
	bool is_orig_;
};

} // namespace RFB
}  // namespace binpac
#endif /* _root_rpmbuild_BUILD_bro_2_5_4_src_analyzer_protocol_rfb_rfb_pac_h */
